import { Account, Context, Pda, PublicKey, RpcAccount, RpcGetAccountOptions, RpcGetAccountsOptions, Serializer } from '@metaplex-foundation/umi';
import { Key, KeyArgs } from '../types';
export type UseAuthorityRecord = Account<UseAuthorityRecordAccountData>;
export type UseAuthorityRecordAccountData = {
    key: Key;
    allowedUses: bigint;
    bump: number;
};
export type UseAuthorityRecordAccountDataArgs = {
    allowedUses: number | bigint;
    bump: number;
};
export declare function getUseAuthorityRecordAccountDataSerializer(context: Pick<Context, 'serializer'>): Serializer<UseAuthorityRecordAccountDataArgs, UseAuthorityRecordAccountData>;
export declare function deserializeUseAuthorityRecord(context: Pick<Context, 'serializer'>, rawAccount: RpcAccount): UseAuthorityRecord;
export declare function fetchUseAuthorityRecord(context: Pick<Context, 'rpc' | 'serializer'>, publicKey: PublicKey, options?: RpcGetAccountOptions): Promise<UseAuthorityRecord>;
export declare function safeFetchUseAuthorityRecord(context: Pick<Context, 'rpc' | 'serializer'>, publicKey: PublicKey, options?: RpcGetAccountOptions): Promise<UseAuthorityRecord | null>;
export declare function fetchAllUseAuthorityRecord(context: Pick<Context, 'rpc' | 'serializer'>, publicKeys: PublicKey[], options?: RpcGetAccountsOptions): Promise<UseAuthorityRecord[]>;
export declare function safeFetchAllUseAuthorityRecord(context: Pick<Context, 'rpc' | 'serializer'>, publicKeys: PublicKey[], options?: RpcGetAccountsOptions): Promise<UseAuthorityRecord[]>;
export declare function getUseAuthorityRecordGpaBuilder(context: Pick<Context, 'rpc' | 'serializer' | 'programs'>): import("@metaplex-foundation/umi").GpaBuilder<UseAuthorityRecord, {
    key: KeyArgs;
    allowedUses: number | bigint;
    bump: number;
}>;
export declare function getUseAuthorityRecordSize(): number;
export declare function findUseAuthorityRecordPda(context: Pick<Context, 'eddsa' | 'programs' | 'serializer'>, seeds: {
    mint: PublicKey;
    useAuthority: PublicKey;
}): Pda;
