import { Context, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { CreateMasterEditionArgs, CreateMasterEditionArgsArgs } from '../types';
export type CreateMasterEditionV3InstructionAccounts = {
    edition?: PublicKey;
    mint: PublicKey;
    updateAuthority?: Signer;
    mintAuthority: Signer;
    payer?: Signer;
    metadata?: PublicKey;
    tokenProgram?: PublicKey;
    systemProgram?: PublicKey;
    rent?: PublicKey;
};
export type CreateMasterEditionV3InstructionData = {
    discriminator: number;
    createMasterEditionArgs: CreateMasterEditionArgs;
};
export type CreateMasterEditionV3InstructionDataArgs = {
    createMasterEditionArgs: CreateMasterEditionArgsArgs;
};
export declare function getCreateMasterEditionV3InstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<CreateMasterEditionV3InstructionDataArgs, CreateMasterEditionV3InstructionData>;
export declare function createMasterEditionV3(context: Pick<Context, 'serializer' | 'programs' | 'eddsa' | 'identity' | 'payer'>, input: CreateMasterEditionV3InstructionAccounts & CreateMasterEditionV3InstructionDataArgs): TransactionBuilder;
