import { Context, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { DelegateArgs, DelegateArgsArgs } from '../types';
export type DelegateInstructionAccounts = {
    delegateRecord?: PublicKey;
    delegate: PublicKey;
    metadata?: PublicKey;
    masterEdition?: PublicKey;
    tokenRecord?: PublicKey;
    mint: PublicKey;
    token?: PublicKey;
    authority?: Signer;
    payer?: Signer;
    systemProgram?: PublicKey;
    sysvarInstructions?: PublicKey;
    splTokenProgram?: PublicKey;
    authorizationRulesProgram?: PublicKey;
    authorizationRules?: PublicKey;
};
export type DelegateInstructionData = {
    discriminator: number;
    delegateArgs: DelegateArgs;
};
export type DelegateInstructionDataArgs = {
    delegateArgs: DelegateArgsArgs;
};
export declare function getDelegateInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<DelegateInstructionDataArgs, DelegateInstructionData>;
export declare function delegate(context: Pick<Context, 'serializer' | 'programs' | 'eddsa' | 'identity' | 'payer'>, input: DelegateInstructionAccounts & DelegateInstructionDataArgs): TransactionBuilder;
