import { Context, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
export type DelegateStandardV1InstructionAccounts = {
    delegateRecord?: PublicKey;
    delegate: PublicKey;
    metadata?: PublicKey;
    masterEdition?: PublicKey;
    tokenRecord?: PublicKey;
    mint: PublicKey;
    token?: PublicKey;
    authority?: Signer;
    payer?: Signer;
    systemProgram?: PublicKey;
    sysvarInstructions?: PublicKey;
    splTokenProgram?: PublicKey;
    authorizationRulesProgram?: PublicKey;
    authorizationRules?: PublicKey;
};
export type DelegateStandardV1InstructionData = {
    discriminator: number;
    delegateStandardV1Discriminator: number;
    amount: bigint;
};
export type DelegateStandardV1InstructionDataArgs = {
    amount: number | bigint;
};
export declare function getDelegateStandardV1InstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<DelegateStandardV1InstructionDataArgs, DelegateStandardV1InstructionData>;
export declare function delegateStandardV1(context: Pick<Context, 'serializer' | 'programs' | 'eddsa' | 'identity' | 'payer'>, input: DelegateStandardV1InstructionAccounts & DelegateStandardV1InstructionDataArgs): TransactionBuilder;
