import { Context, Option, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { MigrationType, MigrationTypeArgs } from '../types';
export type MigrateV1InstructionAccounts = {
    metadata?: PublicKey;
    edition?: PublicKey;
    token: PublicKey;
    tokenOwner: PublicKey;
    mint: PublicKey;
    payer?: Signer;
    authority?: Signer;
    collectionMetadata: PublicKey;
    delegateRecord: PublicKey;
    tokenRecord?: PublicKey;
    systemProgram?: PublicKey;
    sysvarInstructions?: PublicKey;
    splTokenProgram?: PublicKey;
    authorizationRulesProgram?: PublicKey;
    authorizationRules?: PublicKey;
};
export type MigrateV1InstructionData = {
    discriminator: number;
    migrateV1Discriminator: number;
    migrationType: MigrationType;
    ruleSet: Option<PublicKey>;
};
export type MigrateV1InstructionDataArgs = {
    migrationType: MigrationTypeArgs;
    ruleSet: Option<PublicKey>;
};
export declare function getMigrateV1InstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<MigrateV1InstructionDataArgs, MigrateV1InstructionData>;
export declare function migrateV1(context: Pick<Context, 'serializer' | 'programs' | 'eddsa' | 'identity' | 'payer'>, input: MigrateV1InstructionAccounts & MigrateV1InstructionDataArgs): TransactionBuilder;
