import { Context, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { MintArgs, MintArgsArgs } from '../types';
export type MintInstructionAccounts = {
    token: PublicKey;
    tokenOwner?: PublicKey;
    metadata?: PublicKey;
    masterEdition?: PublicKey;
    tokenRecord?: PublicKey;
    mint: PublicKey;
    authority?: Signer;
    delegateRecord?: PublicKey;
    payer?: Signer;
    systemProgram?: PublicKey;
    sysvarInstructions?: PublicKey;
    splTokenProgram?: PublicKey;
    splAtaProgram?: PublicKey;
    authorizationRulesProgram?: PublicKey;
    authorizationRules?: PublicKey;
};
export type MintInstructionData = {
    discriminator: number;
    mintArgs: MintArgs;
};
export type MintInstructionDataArgs = {
    mintArgs: MintArgsArgs;
};
export declare function getMintInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<MintInstructionDataArgs, MintInstructionData>;
export declare function mint(context: Pick<Context, 'serializer' | 'programs' | 'eddsa' | 'identity' | 'payer'>, input: MintInstructionAccounts & MintInstructionDataArgs): TransactionBuilder;
