"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mintNewEditionFromMasterEditionViaVaultProxy = exports.getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const types_1 = require("../types");
function getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        [
            'mintNewEditionFromMasterEditionViaTokenArgs',
            (0, types_1.getMintNewEditionFromMasterEditionViaTokenArgsSerializer)(context),
        ],
    ], {
        description: 'MintNewEditionFromMasterEditionViaVaultProxyInstructionData',
    }), (value) => ({
        ...value,
        discriminator: 13,
    }));
}
exports.getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataSerializer = getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataSerializer;
function mintNewEditionFromMasterEditionViaVaultProxy(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    const newMetadataAccount = input.newMetadata;
    const newEditionAccount = input.newEdition;
    const masterEditionAccount = input.masterEdition;
    const newMintAccount = input.newMint;
    const editionMarkPdaAccount = input.editionMarkPda;
    const newMintAuthorityAccount = input.newMintAuthority;
    const payerAccount = input.payer ?? context.payer;
    const vaultAuthorityAccount = input.vaultAuthority;
    const safetyDepositStoreAccount = input.safetyDepositStore;
    const safetyDepositBoxAccount = input.safetyDepositBox;
    const vaultAccount = input.vault;
    const newMetadataUpdateAuthorityAccount = input.newMetadataUpdateAuthority;
    const metadataAccount = input.metadata;
    const tokenProgramAccount = input.tokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    };
    const tokenVaultProgramAccount = input.tokenVaultProgram;
    const systemProgramAccount = input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    };
    const rentAccount = input.rent;
    keys.push({
        pubkey: newMetadataAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newMetadataAccount, true),
    });
    keys.push({
        pubkey: newEditionAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newEditionAccount, true),
    });
    keys.push({
        pubkey: masterEditionAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(masterEditionAccount, true),
    });
    keys.push({
        pubkey: newMintAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newMintAccount, true),
    });
    keys.push({
        pubkey: editionMarkPdaAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(editionMarkPdaAccount, true),
    });
    signers.push(newMintAuthorityAccount);
    keys.push({
        pubkey: newMintAuthorityAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newMintAuthorityAccount, false),
    });
    signers.push(payerAccount);
    keys.push({
        pubkey: payerAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(payerAccount, true),
    });
    signers.push(vaultAuthorityAccount);
    keys.push({
        pubkey: vaultAuthorityAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(vaultAuthorityAccount, false),
    });
    keys.push({
        pubkey: safetyDepositStoreAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(safetyDepositStoreAccount, false),
    });
    keys.push({
        pubkey: safetyDepositBoxAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(safetyDepositBoxAccount, false),
    });
    keys.push({
        pubkey: vaultAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(vaultAccount, false),
    });
    keys.push({
        pubkey: newMetadataUpdateAuthorityAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newMetadataUpdateAuthorityAccount, false),
    });
    keys.push({
        pubkey: metadataAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(metadataAccount, false),
    });
    keys.push({
        pubkey: tokenProgramAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(tokenProgramAccount, false),
    });
    keys.push({
        pubkey: tokenVaultProgramAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(tokenVaultProgramAccount, false),
    });
    keys.push({
        pubkey: systemProgramAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(systemProgramAccount, false),
    });
    if (rentAccount) {
        keys.push({
            pubkey: rentAccount,
            isSigner: false,
            isWritable: (0, umi_1.checkForIsWritableOverride)(rentAccount, false),
        });
    }
    const data = getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.mintNewEditionFromMasterEditionViaVaultProxy = mintNewEditionFromMasterEditionViaVaultProxy;
//# sourceMappingURL=mintNewEditionFromMasterEditionViaVaultProxy.js.map