"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.puffMetadata = exports.getPuffMetadataInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getPuffMetadataInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([['discriminator', s.u8()]], {
        description: 'PuffMetadataInstructionData',
    }), (value) => ({ ...value, discriminator: 14 }));
}
exports.getPuffMetadataInstructionDataSerializer = getPuffMetadataInstructionDataSerializer;
function puffMetadata(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    const metadataAccount = input.metadata;
    keys.push({
        pubkey: metadataAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(metadataAccount, true),
    });
    const data = getPuffMetadataInstructionDataSerializer(context).serialize({});
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.puffMetadata = puffMetadata;
//# sourceMappingURL=puffMetadata.js.map