"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setCollectionSize = exports.getSetCollectionSizeInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const types_1 = require("../types");
function getSetCollectionSizeInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['setCollectionSizeArgs', (0, types_1.getSetCollectionSizeArgsSerializer)(context)],
    ], { description: 'SetCollectionSizeInstructionData' }), (value) => ({ ...value, discriminator: 34 }));
}
exports.getSetCollectionSizeInstructionDataSerializer = getSetCollectionSizeInstructionDataSerializer;
function setCollectionSize(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    const collectionMetadataAccount = input.collectionMetadata;
    const collectionAuthorityAccount = input.collectionAuthority;
    const collectionMintAccount = input.collectionMint;
    const collectionAuthorityRecordAccount = input.collectionAuthorityRecord;
    keys.push({
        pubkey: collectionMetadataAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(collectionMetadataAccount, true),
    });
    signers.push(collectionAuthorityAccount);
    keys.push({
        pubkey: collectionAuthorityAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(collectionAuthorityAccount, true),
    });
    keys.push({
        pubkey: collectionMintAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(collectionMintAccount, false),
    });
    if (collectionAuthorityRecordAccount) {
        keys.push({
            pubkey: collectionAuthorityRecordAccount,
            isSigner: false,
            isWritable: (0, umi_1.checkForIsWritableOverride)(collectionAuthorityRecordAccount, false),
        });
    }
    const data = getSetCollectionSizeInstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.setCollectionSize = setCollectionSize;
//# sourceMappingURL=setCollectionSize.js.map