"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signMetadata = exports.getSignMetadataInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getSignMetadataInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([['discriminator', s.u8()]], {
        description: 'SignMetadataInstructionData',
    }), (value) => ({ ...value, discriminator: 7 }));
}
exports.getSignMetadataInstructionDataSerializer = getSignMetadataInstructionDataSerializer;
function signMetadata(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    const metadataAccount = input.metadata;
    const creatorAccount = input.creator;
    keys.push({
        pubkey: metadataAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(metadataAccount, true),
    });
    signers.push(creatorAccount);
    keys.push({
        pubkey: creatorAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(creatorAccount, false),
    });
    const data = getSignMetadataInstructionDataSerializer(context).serialize({});
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.signMetadata = signMetadata;
//# sourceMappingURL=signMetadata.js.map