import { Context, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { VerificationArgs, VerificationArgsArgs } from '../types';
export type UnverifyInstructionAccounts = {
    authority?: Signer;
    delegateRecord?: PublicKey;
    metadata: PublicKey;
    collectionMint?: PublicKey;
    collectionMetadata?: PublicKey;
    systemProgram?: PublicKey;
    sysvarInstructions?: PublicKey;
};
export type UnverifyInstructionData = {
    discriminator: number;
    verificationArgs: VerificationArgs;
};
export type UnverifyInstructionDataArgs = {
    verificationArgs: VerificationArgsArgs;
};
export declare function getUnverifyInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<UnverifyInstructionDataArgs, UnverifyInstructionData>;
export declare function unverify(context: Pick<Context, 'serializer' | 'programs' | 'identity'>, input: UnverifyInstructionAccounts & UnverifyInstructionDataArgs): TransactionBuilder;
