"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updatePrimarySaleHappenedViaToken = exports.getUpdatePrimarySaleHappenedViaTokenInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getUpdatePrimarySaleHappenedViaTokenInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([['discriminator', s.u8()]], { description: 'UpdatePrimarySaleHappenedViaTokenInstructionData' }), (value) => ({
        ...value,
        discriminator: 4,
    }));
}
exports.getUpdatePrimarySaleHappenedViaTokenInstructionDataSerializer = getUpdatePrimarySaleHappenedViaTokenInstructionDataSerializer;
function updatePrimarySaleHappenedViaToken(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    const metadataAccount = input.metadata;
    const ownerAccount = input.owner;
    const tokenAccount = input.token;
    keys.push({
        pubkey: metadataAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(metadataAccount, true),
    });
    signers.push(ownerAccount);
    keys.push({
        pubkey: ownerAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(ownerAccount, false),
    });
    keys.push({
        pubkey: tokenAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(tokenAccount, false),
    });
    const data = getUpdatePrimarySaleHappenedViaTokenInstructionDataSerializer(context).serialize({});
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.updatePrimarySaleHappenedViaToken = updatePrimarySaleHappenedViaToken;
//# sourceMappingURL=updatePrimarySaleHappenedViaToken.js.map