import { Context, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
export type UtilizeInstructionAccounts = {
    metadata?: PublicKey;
    tokenAccount: PublicKey;
    mint: PublicKey;
    useAuthority: Signer;
    owner: PublicKey;
    tokenProgram?: PublicKey;
    ataProgram?: PublicKey;
    systemProgram?: PublicKey;
    rent?: PublicKey;
    useAuthorityRecord?: PublicKey;
    burner?: PublicKey;
};
export type UtilizeInstructionData = {
    discriminator: number;
    numberOfUses: bigint;
};
export type UtilizeInstructionDataArgs = {
    numberOfUses: number | bigint;
};
export declare function getUtilizeInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<UtilizeInstructionDataArgs, UtilizeInstructionData>;
export declare function utilize(context: Pick<Context, 'serializer' | 'programs' | 'eddsa'>, input: UtilizeInstructionAccounts & UtilizeInstructionDataArgs): TransactionBuilder;
