"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isDelegateArgs = exports.delegateArgs = exports.getDelegateArgsSerializer = void 0;
const _1 = require(".");
function getDelegateArgsSerializer(context) {
    const s = context.serializer;
    return s.dataEnum([
        [
            'CollectionV1',
            s.struct([
                [
                    'authorizationData',
                    s.option((0, _1.getAuthorizationDataSerializer)(context)),
                ],
            ], { description: 'CollectionV1' }),
        ],
        [
            'SaleV1',
            s.struct([
                ['amount', s.u64()],
                [
                    'authorizationData',
                    s.option((0, _1.getAuthorizationDataSerializer)(context)),
                ],
            ], { description: 'SaleV1' }),
        ],
        [
            'TransferV1',
            s.struct([
                ['amount', s.u64()],
                [
                    'authorizationData',
                    s.option((0, _1.getAuthorizationDataSerializer)(context)),
                ],
            ], { description: 'TransferV1' }),
        ],
        [
            'UpdateV1',
            s.struct([
                [
                    'authorizationData',
                    s.option((0, _1.getAuthorizationDataSerializer)(context)),
                ],
            ], { description: 'UpdateV1' }),
        ],
        [
            'UtilityV1',
            s.struct([
                ['amount', s.u64()],
                [
                    'authorizationData',
                    s.option((0, _1.getAuthorizationDataSerializer)(context)),
                ],
            ], { description: 'UtilityV1' }),
        ],
        [
            'StakingV1',
            s.struct([
                ['amount', s.u64()],
                [
                    'authorizationData',
                    s.option((0, _1.getAuthorizationDataSerializer)(context)),
                ],
            ], { description: 'StakingV1' }),
        ],
        [
            'StandardV1',
            s.struct([['amount', s.u64()]], { description: 'StandardV1' }),
        ],
        [
            'LockedTransferV1',
            s.struct([
                ['amount', s.u64()],
                ['lockedAddress', s.publicKey()],
                [
                    'authorizationData',
                    s.option((0, _1.getAuthorizationDataSerializer)(context)),
                ],
            ], { description: 'LockedTransferV1' }),
        ],
        [
            'ProgrammableConfigV1',
            s.struct([
                [
                    'authorizationData',
                    s.option((0, _1.getAuthorizationDataSerializer)(context)),
                ],
            ], { description: 'ProgrammableConfigV1' }),
        ],
    ], { description: 'DelegateArgs' });
}
exports.getDelegateArgsSerializer = getDelegateArgsSerializer;
function delegateArgs(kind, data) {
    return Array.isArray(data)
        ? { __kind: kind, fields: data }
        : { __kind: kind, ...(data ?? {}) };
}
exports.delegateArgs = delegateArgs;
function isDelegateArgs(kind, value) {
    return value.__kind === kind;
}
exports.isDelegateArgs = isDelegateArgs;
//# sourceMappingURL=delegateArgs.js.map