import { Context, GetDataEnumKind, GetDataEnumKindContent, Option, Serializer } from '@metaplex-foundation/umi';
import { AuthorizationData, AuthorizationDataArgs } from '.';
export type MintArgs = {
    __kind: 'V1';
    amount: bigint;
    authorizationData: Option<AuthorizationData>;
};
export type MintArgsArgs = {
    __kind: 'V1';
    amount: number | bigint;
    authorizationData?: Option<AuthorizationDataArgs>;
};
export declare function getMintArgsSerializer(context: Pick<Context, 'serializer'>): Serializer<MintArgsArgs, MintArgs>;
export declare function mintArgs(kind: 'V1', data: GetDataEnumKindContent<MintArgsArgs, 'V1'>): GetDataEnumKind<MintArgsArgs, 'V1'>;
export declare function isMintArgs<K extends MintArgs['__kind']>(kind: K, value: MintArgs): value is MintArgs & {
    __kind: K;
};
