"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isMintArgs = exports.mintArgs = exports.getMintArgsSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const _1 = require(".");
function getMintArgsSerializer(context) {
    const s = context.serializer;
    return s.dataEnum([
        [
            'V1',
            (0, umi_1.mapSerializer)(s.struct([
                ['amount', s.u64()],
                [
                    'authorizationData',
                    s.option((0, _1.getAuthorizationDataSerializer)(context)),
                ],
            ], { description: 'V1' }), (value) => ({
                ...value,
                authorizationData: value.authorizationData ?? (0, umi_1.none)(),
            })),
        ],
    ], { description: 'MintArgs' });
}
exports.getMintArgsSerializer = getMintArgsSerializer;
function mintArgs(kind, data) {
    return Array.isArray(data)
        ? { __kind: kind, fields: data }
        : { __kind: kind, ...(data ?? {}) };
}
exports.mintArgs = mintArgs;
function isMintArgs(kind, value) {
    return value.__kind === kind;
}
exports.isMintArgs = isMintArgs;
//# sourceMappingURL=mintArgs.js.map