"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPrintSupply = exports.printSupply = exports.getPrintSupplySerializer = void 0;
function getPrintSupplySerializer(context) {
    const s = context.serializer;
    return s.dataEnum([
        ['Zero', s.unit()],
        [
            'Limited',
            s.struct([['fields', s.tuple([s.u64()])]], { description: 'Limited' }),
        ],
        ['Unlimited', s.unit()],
    ], { description: 'PrintSupply' });
}
exports.getPrintSupplySerializer = getPrintSupplySerializer;
function printSupply(kind, data) {
    return Array.isArray(data)
        ? { __kind: kind, fields: data }
        : { __kind: kind, ...(data ?? {}) };
}
exports.printSupply = printSupply;
function isPrintSupply(kind, value) {
    return value.__kind === kind;
}
exports.isPrintSupply = isPrintSupply;
//# sourceMappingURL=printSupply.js.map