"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mintV1 = exports.getMintV1InstructionDataSerializer = void 0;
const mpl_essentials_1 = require("@metaplex-foundation/mpl-essentials");
const umi_1 = require("@metaplex-foundation/umi");
const digitalAsset_1 = require("../digitalAsset");
const generated_1 = require("../generated");
const mintV1_1 = require("../generated/instructions/mintV1");
Object.defineProperty(exports, "getMintV1InstructionDataSerializer", { enumerable: true, get: function () { return mintV1_1.getMintV1InstructionDataSerializer; } });
const mintV1 = (context, input) => {
    const defaultMasterEdition = (0, digitalAsset_1.isFungible)(input.tokenStandard)
        ? undefined
        : (0, generated_1.findMasterEditionPda)(context, { mint: (0, umi_1.publicKey)(input.mint) });
    const defaultTokenOwner = input.token
        ? undefined
        : context.identity.publicKey;
    return (0, mintV1_1.mintV1)(context, {
        masterEdition: input.masterEdition ?? defaultMasterEdition,
        ...input,
        tokenOwner: input.tokenOwner ?? defaultTokenOwner,
        token: input.token ??
            (0, mpl_essentials_1.findAssociatedTokenPda)(context, {
                mint: (0, umi_1.publicKey)(input.mint),
                owner: (0, umi_1.publicKey)(input.tokenOwner ?? defaultTokenOwner),
            }),
    });
};
exports.mintV1 = mintV1;
//# sourceMappingURL=mintV1.js.map